> For the complete documentation index, see [llms.txt](https://docs.wem.io/platform/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.wem.io/platform/wemreference/functions/security/totp.md).

# Totp

{% hint style="info" %}
The **`Totp()`** function calculates a time-based one-time password based on the given secret and given UTC time.

WIKI: <https://en.wikipedia.org/wiki/Time-based_one-time_password>

MyWEM Forum: <https://forum.wem.io/link?threadid=184>

This function is NOT SQL compatible. For more information about SQL compatibility, see our [documentation](/platform/wemreference/sql-compatibility.md).
{% endhint %}

{% hint style="success" %}
Returns a <mark style="color:green;">**`text`**</mark> value based on the given secret and UTC time, containing 6 numbers.\
Returns <mark style="color:red;">**`Unknown`**</mark> if one of the parameter values is unknown or outside the common valid boundaries. May throw a Server500 error when the secret is NOT a proper Base32 value with characters from the collection "`ABCDEFGHIJKLMNOPQRSTUVWXYZ234567`"
{% endhint %}

### Syntax

<details>

<summary><code>Totp(</code><mark style="color:blue;"><code>secret</code></mark><code>)</code></summary>

`Totp( "ABCDEFGHIJKLMNOPQRSTUVWXYZ234567" )`\
*=> "838893" (UtcNow() is implicitly used as date-time value)*

</details>

<details>

<summary><code>Totp(</code><mark style="color:blue;"><code>secret</code></mark><code>, </code><mark style="color:blue;"><code>date</code></mark><code>)</code></summary>

`Totp("ABCDEFGHIJKLMNOPQRSTUVWXYZ234567",` [`Date`](/platform/wemreference/functions/date/date.md)`(2022,05,11,14,15,0))`\
*=> "527549"*

</details>

### Parameters

<table><thead><tr><th width="150">Name</th><th width="150">Type</th><th width="150" align="center">Required</th><th width="248.15953250810662">Description</th><th data-hidden>Required?</th></tr></thead><tbody><tr><td><mark style="color:blue;"><code>secret</code></mark></td><td>Base32 text</td><td align="center"><span data-gb-custom-inline data-tag="emoji" data-code="2611">☑️</span></td><td>secret the password is based on. Must be base32 encoded and must contain any of the characters from the collection as indicated in the syntax example. </td><td>yes</td></tr><tr><td><mark style="color:blue;"><code>date</code></mark></td><td>date time</td><td align="center"><span data-gb-custom-inline data-tag="emoji" data-code="2611">☑️</span></td><td>UTC time or time and interval the password is based on. </td><td>yes</td></tr></tbody></table>


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation by asking a question.

Perform an HTTP GET request on the following URL with the `ask` and `goal` query parameters:

```
GET https://docs.wem.io/platform/wemreference/functions/security/totp.md?ask=<question>&goal=<user_goal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is what the user is ultimately trying to achieve, the reason they need the answer. Sharing it helps GitBook give you a better, more relevant answer. A goal is most helpful when it describes the outcome the user wants rather than restating the question. For example, with `ask=how do I create an API token`, a goal like `automate deployments from our CI pipeline` lets GitBook tailor the answer to that use case.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
